#include "Is_folder_alias.h"
#include <Finder.h>

/*	-------------------------------------------------------------------
	Is_folder_alias		Given a file type, determine whether the item
						is an alias to a folder.  I use assembler to
						declare the types, rather than a static array,
	so that I won't have to worry whether I am using A5 or A4 for globals.
	-------------------------------------------------------------------
*/
Boolean		Is_folder_alias( OSType	file_type )
{
	OSType		*folder_types, *end_types;
	
	asm {
		bra		@start
	@data
		dc.L	kContainerFolderAliasType
		dc.L	kContainerTrashAliasType
		dc.L	kContainerHardDiskAliasType
		dc.L	kContainerFloppyAliasType
		dc.L	kContainerServerAliasType
		dc.L	kSystemFolderAliasType
		dc.L	kAppleMenuFolderAliasType
		dc.L	kStartupFolderAliasType
		dc.L	kPrintMonitorDocsFolderAliasType
		dc.L	kPreferencesFolderAliasType
		dc.L	kControlPanelFolderAliasType
		dc.L	kExtensionFolderAliasType
		dc.L	kExportedFolderAliasType
		dc.L	kDropFolderAliasType
		dc.L	kSharedFolderAliasType
		dc.L	kMountedFolderAliasType
	@start
		lea		@data, A0
		move.L	A0, folder_types
		lea		@start, A0
		move.L	A0, end_types
	}
	
	while (folder_types < end_types)
	{
		if (*folder_types == file_type)
			return true;
		++folder_types;
	}
	
	return false;
}
