//#define	DEBUGGING	1
#include <exceptions.h>
#include <FinderEvents.h>
#include <AppleEvents.h>
#include <Aliases.h>

typedef pascal OSErr (*AESendProcPtr)( AppleEvent * );
#include 	"Move_item.h"

OSErr	Move_item(
/* --> */		FSSpec	*item,
/* --> */		long dest_dir,
/* --> */		AESendProcPtr Sender,
/* --> */		ProcessSerialNumber *finder_psn
)
{
	OSErr		err;
	FSSpec			dest_fss;
	AppleEvent		ae;
	AEDesc			theAddressDesc, aeDirDesc, fileList, listElem;
	AEDesc			place_desc;
	AliasHandle		dirAliasHndl=nil, fileAliasHndl=nil;
	Point			icon_place;
	
	forbid_action( finder_psn->lowLongOfPSN == kNoProcess,
		Finder_not_running, err = 7 );
	
	err = AECreateDesc( typeProcessSerialNumber, (Ptr)finder_psn,
		sizeof(ProcessSerialNumber), &theAddressDesc );
	forbid( err, AECreateDesc_target );

	err = AECreateAppleEvent( kAEFinderEvents, kAEMove,
			&theAddressDesc,
			kAutoGenerateReturnID, kAnyTransactionID, &ae );
	forbid( err, AECreateAppleEvent );

	/*
		The direct object of the AppleEvent is an alias to the folder
		to which we are moving the selection.
	*/
	err = FSMakeFSSpec( item->vRefNum, dest_dir, "\p", &dest_fss );
	forbid( err, FSMakeFSSpec );
	err = NewAlias( NIL, &dest_fss, &dirAliasHndl );
	forbid( err, NewAlias_folder );
	
	HLock( (Handle) dirAliasHndl );
	err = AECreateDesc( typeAlias, (Ptr) *dirAliasHndl,
			GetHandleSize((Handle)dirAliasHndl), &aeDirDesc );
	forbid( err, AECreateDesc_parent );
	err = AEPutParamDesc( &ae, keyDirectObject, &aeDirDesc );
	forbid( err, AEPutParamDesc_parent );
	
	err = AECreateList( nil, 0, false, &fileList );
	forbid( err, AECreateList );
	err = NewAliasMinimal( item, &fileAliasHndl );
	forbid( err, NewAlias_file );
	HLock( (Handle) fileAliasHndl );
	err = AECreateDesc( typeAlias, (Ptr) *fileAliasHndl,
			GetHandleSize((Handle)fileAliasHndl), &listElem );
	forbid( err, AECreateDesc_element );
	err = AEPutDesc( &fileList, 0, &listElem );
	forbid( err, AEPutDesc );
	err = AEPutParamDesc( &ae, keySelection, &fileList );
	forbid( err, AEPutParamDesc_list );
	
	icon_place.h = icon_place.v = -1;
	err = AECreateDesc( typeLongInteger, (Ptr)&icon_place, sizeof(long),
			&place_desc );
	forbid( err, AECreateDesc_place );
	err = AEPutParamDesc( &ae, keyMiscellaneous, &place_desc );
	forbid( err, AEPutParamDesc_place );
	
	err = Sender( &ae );

AEPutParamDesc_place:
	AEDisposeDesc( &place_desc );
AECreateDesc_place:
AEPutParamDesc_list:
AEPutDesc:
	AEDisposeDesc( &listElem );
AECreateDesc_element:
	DisposeHandle( (Handle) fileAliasHndl );
NewAlias_file:
	AEDisposeDesc (&fileList);
AECreateList:
AEPutParamDesc_parent:
	AEDisposeDesc( &aeDirDesc );
AECreateDesc_parent:
	DisposeHandle( (Handle) dirAliasHndl );
	
NewAlias_folder:
FSMakeFSSpec:
	AEDisposeDesc( &ae );
AECreateAppleEvent:
	AEDisposeDesc( &theAddressDesc );
AECreateDesc_target:
Finder_not_running:
	return err;
}